#include <stdio.h>
#include <string.h>

int main(int argc, const char **argv)
{
	int c, siz, flg, i, cc;
	char id[256];

	if (argc <= 2) {
		printf("prompt>pdbtol list   (pdb-file)\n");
		printf("prompt>pdbtol dump   (pdb-file)\n");
		printf("prompt>pdbtol string (pdb-file) (var-name)\n");
		exit(0);
	}

	if (strcmp(argv[1], "list") == 0) {
		FILE *fp = fopen(argv[2], "rb");
		if (fp == NULL) {
			puts("fopen error");
			exit(1);
		}
		printf("format: ");
		do {
			c = fgetc(fp);
			if (c == EOF) break;
			if (c != '\0')
				putchar(c);
		} while (c != '\0');
		printf("\nnote: ");
		do {
			c = fgetc(fp);
			if (c == EOF) break;
			if (c != '\0')
				putchar(c);
		} while (c != '\0');
		putchar('\n');
		putchar('\n');
		for (;;) {
			siz = flg = 0;
			fread(&siz, 1, 4, fp);
			if (siz == 0) break;
			fread(&flg, 1, 4, fp);
			do {
				c = fgetc(fp);
				if (c == EOF) break;
				if (c != '\0')
					putchar(c);
			} while (c != '\0');
			printf(" (%dbytes)\n", siz);
			for (i = 0; i < siz; i++) {
				c = fgetc(fp);
				if (c == EOF) break;
			}
		}
		fclose(fp);
	}

	if (strcmp(argv[1], "dump") == 0) {
		FILE *fp = fopen(argv[2], "rb");
		if (fp == NULL) {
			puts("fopen error");
			exit(1);
		}
		printf("format: ");
		do {
			c = fgetc(fp);
			if (c == EOF) break;
			if (c != '\0')
				putchar(c);
		} while (c != '\0');
		printf("\nnote: ");
		do {
			c = fgetc(fp);
			if (c == EOF) break;
			if (c != '\0')
				putchar(c);
		} while (c != '\0');
		putchar('\n');
		for (;;) {
			putchar('\n');
			siz = flg = 0;
			fread(&siz, 1, 4, fp);
			if (siz == 0) break;
			fread(&flg, 1, 4, fp);
			do {
				c = fgetc(fp);
				if (c == EOF) break;
				if (c != '\0')
					putchar(c);
			} while (c != '\0');
			printf(" (%dbytes) (flags=0x%08x) :\n", siz, flg); // flgs0̂Ƃ͕\ȗ.
			cc = 0;
			for (i = 0; i < siz; i++) {
				c = fgetc(fp);
				if (c == EOF) break;
				printf("%02x ", c);
				if (((i & 15) == 15 || i + 1 == siz) && siz != 4)
					putchar('\n');
				cc = ((cc >> 8) & 0xffffff) | c << 24;
			}
			if (siz == 4)
				printf(" (=%d)\n", cc);
		}
		fclose(fp);
	}

	if (strcmp(argv[1], "string") == 0 && argc >= 4) {
		FILE *fp = fopen(argv[2], "rb");
		if (fp == NULL) {
			puts("fopen error");
			exit(1);
		}
		do {
			c = fgetc(fp);
			if (c == EOF) break;
		} while (c != '\0');
		do {
			c = fgetc(fp);
			if (c == EOF) break;
		} while (c != '\0');
		for (;;) {
			siz = flg = 0;
			fread(&siz, 1, 4, fp);
			if (siz == 0) break;
			fread(&flg, 1, 4, fp);
			for (i = 0; i < 256; i++) {
				c = fgetc(fp);
				if (c == EOF) break;
				id[i] = c;
				if (c == '\0') break;
			}
			if (i >= 256) {
				puts("too long id");
				exit(1);
			}
			cc = strcmp(id, argv[3]);
			for (i = 0; i < siz; i++) {
				c = fgetc(fp);
				if (c == EOF) break;
				if (c == '\0') cc = 1;
				if (c < ' ') c = '.';
				if (cc == 0)
					putchar(c);
			}
			if (strcmp(id, argv[3]) == 0)
				putchar('\n');
		}
		fclose(fp);
	}

	return 0;
}

